package twcsckernel.serverKernel.io;

/**
 * Interfejs writera logw.
 * 
 * @author VMD Group
 * 
 */
public interface LogWriter {

	public static final int USER_LOGIN = 0;

	public static final int USER_REMOTE_LOGOUT = 1;

	public static final int USER_KICK_LOGOUT = 2;

	public static final int ERROR_UNEXPECTED_EXCEPTION = 0;

	public static final int ERROR_LOGIN_PASSWORD = 1;
	
	public static final int ERROR_PLUGIN_LOADING = 2;

	public static final int ERROR_OTHER = 3;

	/**
	 * Zapisuje wiadomo do logu o logowaniu/wylogowaniu.
	 * 
	 * @param message -
	 *            wiaodmo
	 * @param type -
	 *            typ wiadomoci:<br/>
	 *            <ul>
	 *            <li>{@link #USER_LOGIN USER_LOGIN} - pomylne logowanie</li>
	 *            <li>{@link #USER_REMOTE_LOGOUT USER_REMOTE_LOGOUT} - pomylne
	 *            wylogowanie zainicjowane zdalnie</li>
	 *            <li>{@link #USER_KICK_LOGOUT USER_KICK_LOGOUT} - pomylne
	 *            wylogowanie zainicjowane lokalnie przez
	 *            {@link twcsckernel.serverKernel.usr.UserGarbageCollector user garbage collector}
	 *            lub plugin administracyjny</li>
	 *            </ul>
	 */
	public void writeUserLog(String message, int type);

	/**
	 * Zapisuje wiadomo do logu o bdach.
	 * @param message - wiadomo
	 * @param type
	 */
	public void writeErrorLog(String message, int type);

	public void writeInfoLog(String message);

}
