package twcsckernel.serverKernel.io;

import java.io.IOException;
import java.util.Map;

import twcsckernel.serverKernel.utils.TypeData;

/**
 * Interfejs operacji I/O dla zarejestrowanych typw uytkownikw.
 * 
 * @author VMD Group
 * 
 */
public interface TypeIO {
	/**
	 * Wczytuje zarejestrowane typy uytkownikw.
	 * 
	 * @return - mapa zarejestrowanych typw <nazwa_typu,dane>
	 * @throws IOException -
	 *             wyjtek rzucany w przypadku bdu odczytu
	 */
	public Map<String, TypeData> readTypes() throws IOException;

	/**
	 * Metoda dodaje dane do zbioru zarejestrowanych typw.
	 * 
	 * @param typeData -
	 *            dane do dodania
	 * @return - <code>true</code> jeli operacja si udaa (nie byo
	 *         zarejestrowanego typu o podanej nazwie) lub <code>false</code>
	 *         w przeciwnym wypadku.
	 * @throws IOException -
	 *             wyjtek rzucany w przypadku bdu zapisu
	 */
	public boolean addNewType(TypeData typeData) throws IOException;

	/**
	 * Metoda usuwa dane ze zbioru zarejestrowanych typw.
	 * 
	 * @param name -
	 *            nazwa typu do usunicia
	 * @param types -
	 *            aktualna mapa typw (z ktrej rwnie zostanie typ usunity)
	 * @return - <code>true</code> jeli operacja si udaa (by
	 *         zarejestrowany typ o podanej nazwie) lub <code>false</code> w
	 *         przeciwnym wypadku.
	 * @throws IOException -
	 *             wyjtek rzucany w przypadku bdu zapisu
	 */
	public boolean removeType(String name, Map<String, TypeData> types)
			throws IOException;

}
