package twcsckernel.serverKernel.io;

import java.io.IOException;
import java.util.Map;

import twcsckernel.serverKernel.utils.UserData;

/**
 * Interfejs operacji I/O dla zarejestrowanych uytkownikw.
 * 
 * @author VMD Group
 * 
 */
public interface UserIO {

	/**
	 * Wczytuje zarejestrowanych uytkownikw.
	 * 
	 * @return - mapa zarejestrowanych uytkownikw <login,dane>
	 * @throws IOException -
	 *             wyjtek rzucany w przypadku bdu odczytu
	 */
	public Map<String, UserData> readUsers() throws IOException;

	/**
	 * Metoda dodaje dane do zbioru zarejestrowanych uytkownikw.
	 * 
	 * @param userData -
	 *            dane do dodania
	 * @return - <code>true</code> jeli operacja si udaa (nie byo
	 *         zarejestrowanego uytkownika o podanym loginie) lub
	 *         <code>false</code> w przeciwnym wypadku.
	 * @throws IOException -
	 *             wyjtek rzucany w przypadku bdu zapisu
	 */
	public boolean addNewUser(UserData userData) throws IOException;

	/**
	 * Metoda usuwa dane ze zbioru zarejestrowanych uytkownikw.
	 * 
	 * @param login -
	 *            nazwa uytkownika do usunicia
	 * @param users -
	 *            aktualna mapa zarejestrowanych uytkownikw (z ktrej rwnie
	 *            zostanie uytkownik usunity)
	 * @return - <code>true</code> jeli operacja si udaa (by
	 *         zarejestrowany uytkownik o podanym loginie) lub
	 *         <code>false</code> w przeciwnym wypadku.
	 * @throws IOException -
	 *             wyjtek rzucany w przypadku bdu zapisu
	 */
	public boolean removeUser(String login, Map<String, UserData> users)
			throws IOException;

}
