package twcsckernel.serverKernel.plugins;

import twcsckernel.projectbase.common.RemoteAgent;
import twcsckernel.serverKernel.impl.UserImpl;
import twcsckernel.serverKernel.utils.ServerGlobalState;

/**
 * Metoda suca pobieraniu instancji plugina. Kada implementacja
 * powinna posiada bezparametrowy konstruktor.
 * @author VMD Group
 *
 */
public interface PluginBuilder {

	/**
	 * Metoda pobierajca instancj plubigina.
	 * @param user - uytkownik pobierajcy plugin
	 * @param clientAgent - agent zdalny klienckiej czci plugina
	 * @param globalState - stan globalny serwera
	 * @return - instancja plugina
	 */
	public ServerPlugin getInstance(UserImpl user,RemoteAgent clientAgent,ServerGlobalState globalState);
	
}
