package twcsckernel.projectbase.common;

import java.rmi.Remote;
import java.rmi.RemoteException;

import twcsckernel.projectbase.io.FsChangeDescriptor;

/**
 * Interfejs zdalny sucy do monitorowania zmian w systemie
 * plikw. Jest przekazywany z klienta do serwera, a serwer
 * w razie zmiany wywouje metod {@link #fsChangeNotify(FsChangeDescriptor) fsChangeNotify}.
 * Informowanie o zmianach jest zapewnianie przez serwer tylko
 * w ramach wilokrotnego logowania tego samego uytkownika,
 * suy tylko usprawnieniu synchronizacji midzy stanem tych samych
 * uytkownikw i nie zapewnia prawdziwej synchronizacji ze
 * zmianami w systemie plikw. 
 * @author VMD Group
 *
 */
public interface FsChangeListener extends Remote {
    
    /**
     * Metoda suca do informowania o zmianach w systemie plikw.
     * @param fsDescriptor deskryptor zmiany
     */
    public void fsChangeNotify(FsChangeDescriptor fsDescriptor) throws RemoteException;

}
