package twcsckernel.projectbase.common;

import java.io.IOException;
import java.rmi.Remote;
import java.rmi.RemoteException;

import twcsckernel.projectbase.io.ItemNotFoundException;
import twcsckernel.projectbase.io.ReadResult;

/**
 * Fabryka zdalnych strumieni wejcia. Posiada metody pozwalajce na
 * odwzorowanie zachowania <i>java.io.InputStream</i>
 * 
 * @author VMD Group
 * 
 */
public interface ReaderFactory extends Remote {

	public ReadResult read(int streamID) throws RemoteException, IOException,
			ItemNotFoundException;

	public ReadResult read(int streamID, int len) throws RemoteException,
			IOException, ItemNotFoundException;

	public long skip(int streamID, long off) throws RemoteException,
			IOException, ItemNotFoundException;

	public int available(int streamID) throws RemoteException, IOException,
			ItemNotFoundException;

	public void close(int streamID) throws RemoteException, IOException,
			ItemNotFoundException;
}
