package twcsckernel.projectbase.io;

import java.io.Serializable;

/**
 * Dekryptor istniejcego pliku zawierajcy nazw, ciek, rozmiar, dat
 * modyfikacji, atrybut hidden i informacj czy jest to plik czy katalog.
 * (isFile==!isDirectory)
 * 
 * @author VMD Group
 * 
 */
public class FileDescriptor implements Serializable {

	private static final long serialVersionUID = 1L;

	String name;

	String path;

	long length;

	long lastModified;

	boolean isHidden;

	boolean isFile;

	/**
	 * @return <i>true</i> jeli deskryptor okrela plik lub <i>false</i>
	 *         jeli katalog
	 */
	public boolean isFile() {
		return isFile;
	}

	/**
	 * @return czy plik jest ukryty
	 */
	public boolean isHidden() {
		return isHidden;
	}

	/**
	 * @return data ostatniej modyfikacji
	 */
	public long getLastModified() {
		return lastModified;
	}

	/**
	 * @return rozmiar pliku (lub 0 gdy katalog)
	 */
	public long getLength() {
		return length;
	}

	/**
	 * @return nazwa pliku
	 */
	public String getName() {
		return name;
	}

	/**
	 * @return cieka do pliku bez samej nazwy
	 */
	public String getPath() {
		return path;
	}

	public void setIsFile(boolean isFile) {
		this.isFile = isFile;
	}

	public void setHidden(boolean isHidden) {
		this.isHidden = isHidden;
	}

	public void setLastModified(long lastModified) {
		this.lastModified = lastModified;
	}

	public void setLength(long length) {
		this.length = length;
	}

	public void setName(String name) {
		this.name = name;
	}

	public void setPath(String path) {
		this.path = path;
	}

	public FileDescriptor(String name, String path, long length, boolean file,
			boolean hidden, long modified) {
		isFile = file;
		isHidden = hidden;
		lastModified = modified;
		this.length = length;
		this.name = name;
		this.path = path;
	}

	public FileDescriptor() {
	}

}
