package twcsckernel.projectbase.plugins;

import java.io.Serializable;

public class PluginDescriptor implements Serializable {
    private static final long serialVersionUID = 1L;

    public final String author;

    public final String description;

    public final String clientPackagePath;

    public final String serverBuilderPackagePath;

    public final String serverPackagePath;

    public final String name;

    public final boolean isRemote;

    public PluginDescriptor(String author, String description, String name,
            String clientPackagePath, String serverPackagePath,
            boolean isRemote, String serverBuilderPath) {
        this.author = author;
        this.description = description;
        this.name = name;
        this.clientPackagePath = clientPackagePath;
        this.serverPackagePath = serverPackagePath;
        this.isRemote = isRemote;
        this.serverBuilderPackagePath = serverBuilderPath;
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append("author: ");
        sb.append(author);
        sb.append("\ndescription: ");
        sb.append(description);
        sb.append("\nclientPackagePath: ");
        sb.append(clientPackagePath);
        sb.append("\nserverPackagePath: ");
        sb.append(serverPackagePath);
        sb.append("\nremote: ");
        sb.append(isRemote);
        return sb.toString();
    }

    @Override
    public boolean equals(Object obj) {
        if (obj instanceof PluginDescriptor) {
            PluginDescriptor descriptor = (PluginDescriptor) obj;
            return this.author.equals(descriptor.author)
                    &&this.clientPackagePath.equals(descriptor.clientPackagePath)
                    &&this.serverPackagePath.equals(descriptor.serverPackagePath)
                    &&this.serverBuilderPackagePath.equals(descriptor.serverBuilderPackagePath)
                    &&(this.isRemote == descriptor.isRemote);
        }
        return false;
    }
    
    @Override
    public int hashCode() {
        return clientPackagePath.hashCode()*serverPackagePath.hashCode()*serverBuilderPackagePath.hashCode();
    }
    
}
