package twcsckernel.projectbase.rmi.registry;

import java.rmi.RemoteException;
import java.rmi.server.ObjID;
import java.rmi.server.RMIClientSocketFactory;
import java.rmi.server.RMIServerSocketFactory;
import java.rmi.server.RemoteRef;

import sun.rmi.server.UnicastRef;
import sun.rmi.server.UnicastRef2;
import sun.rmi.server.Util;
import sun.rmi.transport.LiveRef;
import sun.rmi.transport.tcp.TCPEndpoint;

public class LocateRegistry {

	private LocateRegistry() {
	}

	public static Registry getRegistry(String host, int port,
			RMIClientSocketFactory csf) throws RemoteException {
		if (port <= 0)
			port = Registry.REGISTRY_PORT;

		if (host == null || host.length() == 0) {
			try {
				host = java.net.InetAddress.getLocalHost().getHostAddress();
			} catch (Exception e) {
				host = "";
			}
		}

		LiveRef liveRef = new LiveRef(new ObjID(ObjID.REGISTRY_ID),
				new TCPEndpoint(host, port, csf, null), false);
		RemoteRef ref = (csf == null) ? new UnicastRef(liveRef)
				: new UnicastRef2(liveRef);

		return (Registry) Util.createProxy(RegistryImpl.class, ref, false);
	}

	public static Registry createRegistry(int port, RMIClientSocketFactory csf,
			RMIServerSocketFactory ssf) throws RemoteException {
		return new RegistryImpl(port, csf, ssf);
	}

	public static Registry createRegistry(int port) throws RemoteException {
		return new RegistryImpl(port);
	}
}
