package twcsckernel.clientKernel.plugins;

import javax.swing.JComponent;

import twcsckernel.clientKernel.desktop.FrameManager;
import twcsckernel.projectbase.common.RemoteAgent;
import twcsckernel.projectbase.plugins.Plugin;

public interface ClientPlugin extends Plugin {

    /**
     * inicjacja pluginu zmienne i inne pierdy 
     */
    void initInstance();

    /**
     * metoda musi zwrcic obiekt JPanel - bedcy wypelnieniem okna aplikacj
     * jako parametr otrzymuje frame managera
     */

    JComponent getJPanel(FrameManager frameMgr);

    /**
     * Metoda ustawia w pluginie agenta serwerowej czci plugina.
     * 
     * @param agent
     *            sieciowy agent serwerowej czsci plugina
     * @throws UnsupportedOperationException
     *             jeli plugin jest lokalny i nie wymaga komunikacji sieciowej
     *             metoda rzuca wyjtek.
     */
    void setForeignAgent(RemoteAgent agent)
            throws UnsupportedOperationException;

    /**
     * Metoda zwraca wasnego agenta sieciowego plugina. Agent jest domylnie
     * zarejestrowany w serwerze RMI (nie wymaga zewntrznej rejestracji). Agent
     * ten jest przekazywany serwerowi.
     * 
     * @return wasny agent sieciowy plugina
     * @throws UnsupportedOperationException
     *             jeli plugin jest lokalny i nie wymaga komunikacji sieciowej
     *             metoda rzuca wyjtek.
     */
    RemoteAgent getOwnAgent() throws UnsupportedOperationException;

    /**
     * Metoda koczca dziaanie plugina (zwolnienie zasobw etc.)
     */
    void disposePlugin();

}
