﻿package twcsckernel.clientKernel.plugins;

import javax.swing.JComponent;

import twcsckernel.clientKernel.desktop.FrameManager;
import twcsckernel.projectbase.common.RemoteAgent;
import twcsckernel.projectbase.plugins.Plugin;

public interface ClientPlugin extends Plugin {

    /**
     * inicjacja pluginu zmienne i inne pierdy 
     */
    void initInstance();

    /**
     * metoda musi zwrócic obiekt JPanel - bedący wypelnieniem okna aplikacj
     * jako parametr otrzymuje frame managera
     */

    JComponent getJPanel(FrameManager frameMgr);

    /**
     * Metoda ustawia w pluginie agenta serwerowej czści plugina.
     * 
     * @param agent
     *            sieciowy agent serwerowej czśsci plugina
     * @throws UnsupportedOperationException
     *             jeśli plugin jest lokalny i nie wymaga komunikacji sieciowej
     *             metoda rzuca wyjątek.
     */
    void setForeignAgent(RemoteAgent agent)
            throws UnsupportedOperationException;

    /**
     * Metoda zwraca własnego agenta sieciowego plugina. Agent jest domyślnie
     * zarejestrowany w serwerze RMI (nie wymaga zewnętrznej rejestracji). Agent
     * ten jest przekazywany serwerowi.
     * 
     * @return własny agent sieciowy plugina
     * @throws UnsupportedOperationException
     *             jeśli plugin jest lokalny i nie wymaga komunikacji sieciowej
     *             metoda rzuca wyjątek.
     */
    RemoteAgent getOwnAgent() throws UnsupportedOperationException;

    /**
     * Metoda kończąca działanie plugina (zwolnienie zasobów etc.)
     */
    void disposePlugin();

}
