package twcsckernel.clientKernel.plugins;

import java.lang.reflect.Constructor;
import java.lang.reflect.InvocationTargetException;



/**
 * Klasa narzędziowa  
 *
 */
public class ClientPluginLoader {
    
    /**
     *  tworzy instancje pluginu o podanej scieżce pakietowej
     **/
    public static ClientPlugin createPlugin(String pluginClassPath
            ) {
        ClientPlugin plugin = null;
        Class pluginDefinition;
        //Class[] intArgsClass = new Class[] { String.class };
        //Object[] intArgs = new Object[] { desc };
        Constructor intArgsConstructor;

        try {
            pluginDefinition = Class.forName(pluginClassPath);
            intArgsConstructor = pluginDefinition
                    .getConstructor();//intArgsClass);
            plugin = (ClientPlugin) createObject(intArgsConstructor, null); //intArgs);
        } catch (ClassNotFoundException e) {
            System.out.println(e);
        } 
    catch (NoSuchMethodException e) {
            System.out.println(e);
        }
        return plugin;
    }

    private static Object createObject(Constructor constructor,
            Object[] arguments) {
        Object object = null;
        try {
            object = constructor.newInstance(arguments);
            return object;
        } catch (InstantiationException e) {
            System.out.println(e);
        } catch (IllegalAccessException e) {
            System.out.println(e);
        } catch (IllegalArgumentException e) {
            System.out.println(e);
        } catch (InvocationTargetException e) {
            System.out.println(e);
        }
        return object;
    }

}
