package twcsckernel.serverKernel.plugins;

import twcsckernel.projectbase.common.RemoteAgent;
import twcsckernel.serverKernel.impl.UserImpl;
import twcsckernel.serverKernel.utils.ServerGlobalState;

/**
 * Metoda służąca pobieraniu instancji plugina. Każda implementacja
 * powinna posiadać bezparametrowy konstruktor.
 * @author VMD Group
 *
 */
public interface PluginBuilder {

	/**
	 * Metoda pobierająca instancję plubigina.
	 * @param user - użytkownik pobierający plugin
	 * @param clientAgent - agent zdalny klienckiej części plugina
	 * @param globalState - stan globalny serwera
	 * @return - instancja plugina
	 */
	public ServerPlugin getInstance(UserImpl user,RemoteAgent clientAgent,ServerGlobalState globalState);
	
}
