package twcsckernel.serverKernel.usr;

import java.io.IOException;

/**
 * Wyjątek opisujący błąd logowania do zbioru zalogowanych użytkowników.
 * Przyczyną wyjątku może być albo próba wielokrotnego zalogowania, albo
 * błąd przy tworzeniu managera bezpieczeństwa dla danego użytkownika.
 * @author VMD Group
 *
 */
public class LoginException extends IOException {

	private static final long serialVersionUID = 1L;

	public static final int MULTIPLE_LOGIN = 0;

	public static final int SECURITY_MANAGER_ERROR = 1;

	private final int excReason;

	public LoginException(int reason) {
		super();
		excReason = reason;
	}

	public LoginException(String message, int reason) {
		super(message);
		excReason = reason;
	}

	public int getReason() {
		return excReason;
	}

}
