package twcsckernel.serverKernel.utils;

import twcsckernel.serverKernel.io.LogWriter;
import twcsckernel.serverKernel.plugins.PluginHandleContainer;
import twcsckernel.serverKernel.usr.LoggedUsersManager;

/**
 * Klasa reprezentująca globalny stan serwera.
 * @author VMD Group
 *
 */
public class ServerGlobalState {

	/**
	 * Manager zalogowanych użytkowników.
	 */
	public final LoggedUsersManager loggedUsers;

	/**
	 * Kontener pluginów.
	 */
	public final PluginHandleContainer pluginHandleContainer;

	/**
	 * Zarejestrowane typy użytkowników.
	 */
	public final RegisteredTypes registeredTypes;

	/**
	 * Zarejestrowani użytkownicy.
	 */
	public final RegisteredUsers registeredUsers;
	
	/**
	 * Writer logów.
	 */
	public final LogWriter logWriter;

	public ServerGlobalState(LoggedUsersManager loggedUsers,
			PluginHandleContainer handleContainer, RegisteredTypes regTypes,
			RegisteredUsers regUsers,LogWriter logWriter) {
		this.loggedUsers = loggedUsers;
		this.pluginHandleContainer = handleContainer;
		this.registeredTypes = regTypes;
		this.registeredUsers = regUsers;
		this.logWriter=logWriter;
	}

}
