﻿package twcsckernel.projectbase.common;

import java.rmi.Remote;
import java.rmi.RemoteException;

import twcsckernel.projectbase.io.FsChangeDescriptor;

/**
 * Interfejs zdalny służący do monitorowania zmian w systemie
 * plików. Jest przekazywany z klienta do serwera, a serwer
 * w razie zmiany wywołuje metodę {@link #fsChangeNotify(FsChangeDescriptor) fsChangeNotify}.
 * Informowanie o zmianach jest zapewnianie przez serwer tylko
 * w ramach wilokrotnego logowania tego samego użytkownika,
 * służy tylko usprawnieniu synchronizacji między stanem tych samych
 * użytkowników i nie zapewnia prawdziwej synchronizacji ze
 * zmianami w systemie plików. 
 * @author VMD Group
 *
 */
public interface FsChangeListener extends Remote {
    
    /**
     * Metoda służąca do informowania o zmianach w systemie plików.
     * @param fsDescriptor deskryptor zmiany
     */
    public void fsChangeNotify(FsChangeDescriptor fsDescriptor) throws RemoteException;

}
