package twcsckernel.projectbase.common;

import java.rmi.Remote;
import java.rmi.RemoteException;

/**
 * Interfejs serwera logowania zwracający obiekt zalogowanego użytkownika.
 * 
 * @author VMD Group
 * 
 */
public interface RemoteServer extends Remote {

	/**
	 * Metoda logowania do serwera.
	 * 
	 * @param name -
	 *            login użytkownika
	 * @param password -
	 *            hasło użytkownika
	 * @return - obiekt zdalny użytkownika
	 * @throws RemoteException -
	 *             standardowy wyjątek operacji zdalnej
	 */
	public User login(String name, String password) throws RemoteException;
}
