﻿/**
 * 
 */
package twcsckernel.projectbase.io;

import java.io.Serializable;

/**
 * Klasa reprezentująca wynik odczytu ze strumienia.
 * Jest klasą pomocniczą klasy ReaderFactory, która
 * serializuje wynik odczytu (wynik <i>int</i> zwracany
 * przez metodę read InputStream oraz tablicę
 * odczytanych bajtów ze strumienia).
 * @author VMD Group
 *
 */
public class ReadResult implements Serializable {
	private static final long serialVersionUID = 1L;

	/**
	 * Wynik metody <i>int read()</i> lub
     * <i>int read(byte[] b)</i> z klasy InputStream.
     * 
	 */
	public final int readResult;
	/**
	 * Tablica bajtów <i>buffer</i>, do której metoda
     * <i>int read(byte[] buffer)</i> odczytuje bajty ze
     * strumienia.
     * 
	 */
	public final byte[] buffer;
	
	/**
     * Tworzy obiekt inicjalizując wymagane pola finalne.
	 * @param readResult - {@link #readResult wynik}
	 * @param b - {@link #buffer bufor}
	 */
	public ReadResult(int readResult,byte[] b)
	{
		this.readResult=readResult;
		this.buffer=b;
	}
	
}
