package twcsckernel.projectbase.rmi.registry;

import java.rmi.NotBoundException;
import java.rmi.Remote;
import java.rmi.RemoteException;
import java.rmi.server.ObjID;
import java.rmi.server.RMIClientSocketFactory;
import java.rmi.server.RMIServerSocketFactory;

import sun.rmi.server.UnicastServerRef;
import sun.rmi.server.UnicastServerRef2;
import sun.rmi.transport.LiveRef;

public class RegistryImpl extends java.rmi.server.RemoteServer implements
		Registry {

	private static final long serialVersionUID = 1L;

	private static ObjID id = new ObjID(0);

	private Remote remoteServer = null;

	public RegistryImpl(int i) throws RemoteException {
		LiveRef liveref = new LiveRef(id, i);
		setup(new UnicastServerRef(liveref));
	}

	public RegistryImpl(int i, RMIClientSocketFactory rmiclientsocketfactory,
			RMIServerSocketFactory rmiserversocketfactory)
			throws RemoteException {
		LiveRef liveref = new LiveRef(id, i, rmiclientsocketfactory,
				rmiserversocketfactory);
		setup(new UnicastServerRef2(liveref));
	}

	private void setup(UnicastServerRef unicastserverref)
			throws RemoteException {
		ref = unicastserverref;
		unicastserverref.exportObject(this, null, true);
	}

	public static ObjID getID() {
		return id;
	}

	public Remote getRemoteServer() throws RemoteException, NotBoundException {
		if (remoteServer == null)
			throw new NotBoundException();
		return remoteServer;
	}

	public void registerRemoteServer(Remote server) {
		remoteServer = server;
	}

}
