package put.cs.vmd.gui;

import java.awt.CardLayout;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.GridLayout;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Map;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

import put.cs.vmd.server.VMDserver;
import put.cs.vmd.server.VMDserver.Command;

public class GUIServer {
	private static final int HEIGHT = 300;
	private static final int WIDTH = 600;

	VMDserver vmdServer;
	JButton start = new JButton("Start");

	JPanel cards = new JPanel();

	CardLayout cardLayout = new CardLayout();

	JTextField portText = new JTextField(new Integer(VMDserver.DEFAULT_PORT)
			.toString());

	JTextField infoText = new JTextField("console");

	JTextField errorText = new JTextField("console");

	JTextField userText = new JTextField("console");

	JTextField userPathText = new JTextField(VMDserver.DEFAULT_USERS_CSV);

	JTextField pluginText = new JTextField(VMDserver.DEFAULT_PLUGINS_PATH);

	JTextField typeText = new JTextField(VMDserver.DEFAULT_TYPES_CSV);

	JTextField timeText = new JTextField(new Integer(
			VMDserver.DEFAULT_CONNECTION_TIMEOUT).toString());

	JTextField garbageText = new JTextField(new Integer(
			VMDserver.DEFAULT_GARBAGE_INTERVAL).toString());

	JButton noWork = new JButton("Wyłączenie serwera");

	Map<String, Command> commands;

	JFrame frame;

	public void newFrame() {

		frame = new JFrame("VMDServer");
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		Container contentPane = frame.getContentPane();
		contentPane.add(cards);
		frame.setSize(WIDTH, HEIGHT);
		setLocation();
		cards.setLayout(cardLayout);
		cards.add(getInitializePanel(), "INITIALIZE");
		cards.add(getWorkingPanel(), "WORKING");
		cardLayout.show(cards, "INITIALIZE");
		start.addActionListener(buttonListener);
		noWork.addActionListener(noWorkListener);
		frame.setResizable(false);
		frame.setVisible(true);
	}

	private void setLocation() {
		Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
		frame.setLocation((screenSize.width - frame.getSize().width) / 2,
				(screenSize.height - frame.getSize().height) / 2);
	}

	private JPanel getInitializePanel() {
		JPanel panel = new JPanel();
		GridLayout gridLayout = new GridLayout(10, 2);
		panel.setLayout(gridLayout);
		JLabel portLabel = new JLabel("  numer portu usługi :");
		JLabel infoLabel = new JLabel("  scieżka pliku logu informacyjnego :");
		JLabel errorLabel = new JLabel("  scieżka pliku logu o błędach  :");
		JLabel userLabel = new JLabel("  scieżka pliku logu użytkowników :");
		JLabel pluginLabel = new JLabel("  scieżka katalogu pluginów :");
		JLabel userPathLabel = new JLabel("  scieżka do pliku uzytkowników :");
		JLabel typePathLabel = new JLabel("  scieżka do pliku typów:");
		JLabel timeLabel = new JLabel(
				"  timeout próby łączenia pasywnego(ms) :");
		JLabel garbageLabel = new JLabel(
				"  interwał user garbage collectora(ms) :");

		panel.add(portLabel);
		panel.add(portText);

		panel.add(infoLabel);
		panel.add(infoText);

		panel.add(errorLabel);
		panel.add(errorText);

		panel.add(userLabel);
		panel.add(userText);

		panel.add(userPathLabel);
		panel.add(userPathText);

		panel.add(typePathLabel);
		panel.add(typeText);

		panel.add(pluginLabel);
		panel.add(pluginText);

		panel.add(timeLabel);
		panel.add(timeText);

		panel.add(garbageLabel);
		panel.add(garbageText);

		panel.add(start);

		return panel;

	}

	private JPanel getWorkingPanel() {
		JPanel panel = new JPanel();
		panel.add(noWork);
		return panel;
	}

	ActionListener noWorkListener = new ActionListener() {
		public void actionPerformed(ActionEvent arg0) {
			vmdServer.shutdown(0);
			System.exit(0);
		}
	};

	ActionListener buttonListener = new ActionListener() {
		public void actionPerformed(ActionEvent arg0) {
			frame.setSize(WIDTH, 70);
			setLocation();
			cardLayout.show(cards, "WORKING");

			Command command = commands.get("ilog");

			if (!infoText.getText().equals("console"))
				try {
					command.execute(infoText.getText());
				} catch (Exception e) {
					System.out.print("blad z plikiem logu operacji\n");
				}
			command = commands.get("elog");
			if (!errorText.getText().equals("console"))
				try {
					command.execute(errorText.getText());
				} catch (Exception e) {
					System.out.print("blad z plikiem logo bledow\n");
				}
			command = commands.get("ulog");
			if (!userText.getText().equals("console"))
				try {
					command.execute(userText.getText());
				} catch (Exception e) {
					System.out.print("blad z plikiem logu uzytkownikow\n");
				}
			command = commands.get("plugins");
			try {
				command.execute(pluginText.getText());
			} catch (Exception e) {
				System.out.print("blad z plikiem pluginow");
			}
			command = commands.get("upath");
			try {
				command.execute(userPathText.getText());
			} catch (Exception e) {
				System.out
						.print("blad ze sciazka zarejestrowanych uzytkownikow");
			}
			command = commands.get("tpath");
			try {
				command.execute(typeText.getText());
			} catch (Exception e) {
				System.out.print("blad ze sciazka zarejestrowanych typow");
			}
			command = commands.get("ct");
			try {
				command.execute(timeText.getText());
			} catch (Exception e) {
				System.out
						.print("blad z ustawieniem czasu proby dla polaczenia");
			}
			command = commands.get("gc");
			try {
				command.execute(garbageText.getText());
			} catch (Exception e) {
				System.out
						.print("blad z ustawieniem czasu proby dla garbage collectora");
			}

			new Thread() {
				// @Override
				public void run() {
					vmdServer.start();
				}
			}.start();
		}
	};

	public GUIServer(Map<String, Command> map, VMDserver server) {
		commands = map;
		vmdServer = server;
	}

}
