package put.cs.vmd.utils;

import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectOutputStream;

import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComponent;
import javax.swing.JEditorPane;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextArea;
import javax.swing.WindowConstants;

import twcsckernel.projectbase.plugins.PluginDescriptor;

/**
 * PluginDescriptorGenerator generuje na podstawie danych dostarczonych przez
 * użytkownika generuje plik zawierający serializowany obiekt PluginDescriptor
 * 
 */
public class PluginDescriptorGenerator {
    /**
     * @param args
     */
    public static void main(String[] args) {

        JFrame jf = new JFrame("PluginDescriptorGenerator");
        jf.setSize(400, 200);
        Container cp = jf.getContentPane();
        cp.setLayout(new BorderLayout());
        cp.add(PluginDescriptorGenerator.getGeneratorPanel(),
                BorderLayout.CENTER);
        jf.setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
        jf.setVisible(true);

    }

    /**
     * 
     */
    private static JComponent getGeneratorPanel() {
        final JPanel main = new JPanel();
        main.setSize(400, 200);
        main.setLayout(new GridLayout(8, 2, 2, 2));
        main.add(new JLabel("Author: "));
        final JEditorPane author = new JEditorPane();
        main.add(author);
        main.add(new JLabel("Description: "));
        final JTextArea description = new JTextArea("");
        main.add(description);
        main.add(new JLabel("Plugin Name: "));
        final JEditorPane name = new JEditorPane();
        main.add(name);
        main.add(new JLabel("Client Packag Path: "));
        final JEditorPane clientPP = new JEditorPane();
        main.add(clientPP);
        main.add(new JLabel("Server Packag Path: "));
        final JEditorPane serverPP = new JEditorPane();
        main.add(serverPP);
        main.add(new JLabel("Sevrer Builder Path: "));
        final JEditorPane builder = new JEditorPane();
        main.add(builder);
        main.add(new JLabel(""));
        final JCheckBox isRemote = new JCheckBox("Remote");
        main.add(isRemote);
        main.add(new JLabel(""));
        JButton button = new JButton("Save Descriptor");
        button.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent e) {
                JFileChooser jfc = new JFileChooser();
                if (JFileChooser.APPROVE_OPTION== jfc.showSaveDialog(main)) {
                    PluginDescriptor pd = new PluginDescriptor(author.getText(),
                            description.getText(), name.getText(), clientPP
                                    .getText(), serverPP.getText(), isRemote
                                    .isSelected(), builder.getText());
                    
                    try {
                        writeSettingsFile(pd, jfc.getSelectedFile().getPath());
                    } catch (IOException e1) {
                        e1.printStackTrace();
                    }
                }
            }
        });
        main.add(button);

        return main;
    }

    private static void writeSettingsFile(Object obj, String path)
            throws IOException {
        FileOutputStream fileOut = new FileOutputStream(path);
        ObjectOutputStream out = new ObjectOutputStream(fileOut);
        out.writeObject(obj);
    }
}
